#pragma once

#include <filesystem>

#include <RobotAPI/libraries/armem/core/base/CoreSegmentBase.h>
#include <RobotAPI/libraries/armem/core/wm/memory_definitions.h>

#include "ProviderSegment.h"


namespace armarx::armem::d_ltm
{

    /**
     * @brief Data of a core segment containing multiple provider segments.
     */
    class CoreSegment :
        public base::CoreSegmentBase<ProviderSegment, CoreSegment>
    {
        using Base = base::CoreSegmentBase<ProviderSegment, CoreSegment>;

    public:

        using Base::CoreSegmentBase;


        // Conversion
        wm::CoreSegment convert() const;

        // Filesystem connection
        void reload(const std::shared_ptr<std::filesystem::path>&);
        void append(const wm::CoreSegment&);

    private:
        std::filesystem::path _fullPath() const;
        std::filesystem::path _fullPath(const std::filesystem::path&) const;

    public:
        std::shared_ptr<std::filesystem::path> path;
    };

}
