#pragma once

#include <filesystem>

#include <RobotAPI/libraries/armem/core/base/EntitySnapshotBase.h>
#include <RobotAPI/libraries/armem/core/wm/memory_definitions.h>

#include "EntityInstance.h"

#include <RobotAPI/libraries/aron/core/navigator/type/forward_declarations.h>


namespace armarx::armem::d_ltm
{

    /**
     * @brief Data of an entity at one point in time.
     */
    class EntitySnapshot :
        public base::EntitySnapshotBase<EntityInstance, EntitySnapshot>
    {
        using Base = base::EntitySnapshotBase<EntityInstance, EntitySnapshot>;

    public:

        using Base::EntitySnapshotBase;


        // Conversion
        void reload(const std::shared_ptr<std::filesystem::path>&);
        wm::EntitySnapshot convert(const aron::typenavigator::NavigatorPtr& expectedStructure) const;

        // FS connection
        void setTo(const wm::EntitySnapshot&);

    private:
        std::filesystem::path _fullPath() const;
        std::filesystem::path _fullPath(const std::filesystem::path&) const;

    public:
        std::shared_ptr<std::filesystem::path> path;
    };
}
