#pragma once

#include "ProviderSegment.h"
#include "mongodb/MongoDBConnectionManager.h"

#include <RobotAPI/libraries/armem/core/base/CoreSegmentBase.h>
#include <RobotAPI/libraries/armem/core/wm/memory_definitions.h>


namespace armarx::armem::ltm
{

    /**
     * @brief Data of a core segment containing multiple provider segments.
     */
    class CoreSegment :
        public base::CoreSegmentBase<ProviderSegment, CoreSegment>
    {
        using Base = base::CoreSegmentBase<ProviderSegment, CoreSegment>;

    public:

        using Base::CoreSegmentBase;


        // Conversion
        wm::CoreSegment convert() const;

        // MongoDB connection
        void reload();
        void append(const wm::CoreSegment&);

    public:

        MongoDBConnectionManager::MongoDBSettings dbsettings;

    };

}
