#include "EntityInstance.h"

#include <ArmarXCore/core/exceptions/local/ExpressionException.h>


namespace armarx::armem::ltm
{

    bool EntityInstance::equalsDeep(const EntityInstance& other) const
    {
        return id() == other.id() && _metadata == other.metadata();
    }

    void EntityInstance::update(const EntityUpdate& update)
    {
        ARMARX_CHECK_FITS_SIZE(this->index(), update.instancesData.size());

        this->_metadata.confidence = update.confidence;
        this->_metadata.timeCreated = update.timeCreated;
        this->_metadata.timeSent = update.timeSent;
        this->_metadata.timeArrived = update.timeArrived;
    }

}
