#pragma once

#include <RobotAPI/libraries/armem/core/base/EntityInstanceBase.h>


namespace armarx::armem::ltm
{

    using EntityInstanceMetadata = base::EntityInstanceMetadata;


    /**
     * @brief Data of a single entity instance.
     */
    class EntityInstance :
        public base::EntityInstanceBase<base::NoData, EntityInstanceMetadata>
    {
        using Base = base::EntityInstanceBase<base::NoData, EntityInstanceMetadata>;

    public:

        using Base::EntityInstanceBase;


        /**
         * @brief Fill `*this` with the update's values.
         * @param update The update.
         * @param index The instances index.
         */
        void update(const EntityUpdate& update);

        bool equalsDeep(const EntityInstance& other) const;

    };
}
