#pragma once

#include "EntityInstance.h"
#include "mongodb/MongoDBConnectionManager.h"

#include <RobotAPI/libraries/armem/core/base/EntitySnapshotBase.h>
#include <RobotAPI/libraries/armem/core/wm/memory_definitions.h>

#include <RobotAPI/libraries/aron/core/navigator/type/forward_declarations.h>


namespace armarx::armem::ltm
{

    /**
     * @brief Data of an entity at one point in time.
     */
    class EntitySnapshot :
        public base::EntitySnapshotBase<EntityInstance, EntitySnapshot>
    {
        using Base = base::EntitySnapshotBase<EntityInstance, EntitySnapshot>;

    public:

        using Base::EntitySnapshotBase;


        // Conversion
        wm::EntitySnapshot convert(const aron::typenavigator::NavigatorPtr& = nullptr) const;

        // MongoDB connection
        void reload();
        void setTo(const wm::EntitySnapshot&, const armem::Time& t);


    public:

        MongoDBConnectionManager::MongoDBSettings dbsettings;

    };
}
