#pragma once

#include "Entity.h"
#include "mongodb/MongoDBConnectionManager.h"

#include <RobotAPI/libraries/armem/core/base/ProviderSegmentBase.h>
#include <RobotAPI/libraries/armem/core/wm/memory_definitions.h>


namespace armarx::armem::ltm
{

    /**
     * @brief Data of a provider segment containing multiple entities.
     */
    class ProviderSegment :
        public base::ProviderSegmentBase<Entity, ProviderSegment>
    {
        using Base = base::ProviderSegmentBase<Entity, ProviderSegment>;

    public:

        using Base::ProviderSegmentBase;


        // Conversion
        wm::ProviderSegment convert() const;

        // MongoDB connection
        void reload();
        void append(const wm::ProviderSegment&);

    public:
        MongoDBConnectionManager::MongoDBSettings dbsettings;
    };

}
