#include "operations.h"


namespace armarx
{

    std::vector<aron::datanavigator::DictNavigatorPtr>
    armem::getAronData(const wm::EntitySnapshot& snapshot)
    {
        std::vector<aron::datanavigator::DictNavigatorPtr> result;
        snapshot.forEachChild([&result](const wm::EntityInstance & instance)
        {
            result.push_back(instance.data());
            return true;
        });
        return result;
    }


    armem::EntityUpdate armem::toEntityUpdate(const wm::EntitySnapshot& snapshot)
    {
        EntityUpdate up;
        up.entityID = snapshot.id().getEntityID();
        up.timeCreated = snapshot.time();
        up.instancesData = getAronData(snapshot);
        return up;
    }

}



