#pragma once

#include "wm/memory_definitions.h"


/*
 * Functions performing some "advanced" operations on the memory
 * data structure, which are using their public API but should not
 * be part of it.
 */

namespace armarx::armem
{

    std::vector<aron::datanavigator::DictNavigatorPtr>
    getAronData(const wm::EntitySnapshot& snapshot);

    EntityUpdate toEntityUpdate(const wm::EntitySnapshot& snapshot);


    template <class ContainerT>
    Commit toCommit(const ContainerT& container)
    {
        Commit commit;
        container.forEachSnapshot([&commit](const wm::EntitySnapshot & snapshot)
        {
            commit.add(toEntityUpdate(snapshot));
            return true;
        });
        return commit;
    }

}

