#include "json_conversions.h"

#include <RobotAPI/libraries/aron/core/Debug.h>
#include <RobotAPI/libraries/aron/core/io/dataIO/visitor/Visitor.h>
#include <RobotAPI/libraries/aron/core/io/dataIO/converter/Converter.h>
#include <RobotAPI/libraries/aron/core/io/dataIO/reader/nlohmannJSON/NlohmannJSONReader.h>
#include <RobotAPI/libraries/aron/core/io/dataIO/writer/nlohmannJSON/NlohmannJSONWriter.h>


namespace armarx::armem
{
    void from_aron(const aron::datanavigator::DictNavigatorPtr& aron, nlohmann::json& j)
    {
        aron::dataIO::writer::NlohmannJSONWriter dataWriter;
        aron::dataIO::Visitor::VisitAndSetup(dataWriter, aron);
        j = dataWriter.getResult();
    }

    void to_aron(aron::datanavigator::DictNavigatorPtr& a, const nlohmann::json& e,
                 const aron::typenavigator::NavigatorPtr& expectedStructure)
    {
        aron::dataIO::reader::NlohmannJSONReader dataReader(e);
        aron::dataIO::writer::NavigatorWriter navWriter;
        aron::dataIO::Converter::ReadAndConvert(dataReader, navWriter, expectedStructure);
        a = aron::datanavigator::DictNavigator::DynamicCastAndCheck(navWriter.getResult());
    }
}
