#pragma once

#include <RobotAPI/libraries/armem/core/diskmemory/Memory.h>
#include <RobotAPI/libraries/armem/server/query_proc/base.h>


namespace armarx::armem::server::query_proc::d_ltm
{
    static const base::QueryTarget queryTarget = query::data::QueryTarget::LTM;


    class EntityQueryProcessor :
        public base::EntityQueryProcessorBase<queryTarget, armem::d_ltm::Entity, armem::d_ltm::Entity>
    {
    };

    class ProviderSegmentQueryProcessor :
        public base::ProviderSegmentQueryProcessorBase <queryTarget, armem::d_ltm::ProviderSegment, armem::d_ltm::ProviderSegment, EntityQueryProcessor >
    {
    };

    class CoreSegmentQueryProcessor :
        public base::CoreSegmentQueryProcessorBase<queryTarget, armem::d_ltm::CoreSegment, armem::d_ltm::CoreSegment, ProviderSegmentQueryProcessor>
    {
    };

    class MemoryQueryProcessor :
        public base::MemoryQueryProcessorBase <queryTarget, armem::d_ltm::Memory, armem::d_ltm::Memory, CoreSegmentQueryProcessor >
    {
    };

}
