#pragma once

#include <RobotAPI/libraries/armem/core/longtermmemory/Memory.h>
#include <RobotAPI/libraries/armem/server/query_proc/base.h>


namespace armarx::armem::server::query_proc::ltm
{
    static const base::QueryTarget queryTarget = query::data::QueryTarget::LTM;


    class EntityQueryProcessor :
        public base::EntityQueryProcessorBase<queryTarget, armem::ltm::Entity, armem::ltm::Entity>
    {
    };

    class ProviderSegmentQueryProcessor :
        public base::ProviderSegmentQueryProcessorBase <queryTarget, armem::ltm::ProviderSegment, armem::ltm::ProviderSegment, EntityQueryProcessor >
    {
    };

    class CoreSegmentQueryProcessor :
        public base::CoreSegmentQueryProcessorBase <queryTarget, armem::ltm::CoreSegment, armem::ltm::CoreSegment, ProviderSegmentQueryProcessor>
    {
    };

    class MemoryQueryProcessor :
        public base::MemoryQueryProcessorBase <queryTarget, armem::ltm::Memory, armem::ltm::Memory, CoreSegmentQueryProcessor >
    {
    };

}
