#include "wm.h"



namespace armarx::armem::server::query_proc::wm::detail
{

    HasDataMode::HasDataMode(armem::DataMode dataMode) : dataMode(dataMode)
    {
    }

}


namespace armarx::armem::server::query_proc::wm
{

    ProviderSegmentQueryProcessor::ProviderSegmentQueryProcessor(DataMode dataMode) :
        ProviderSegmentQueryProcessorBase(dataMode), HasDataMode(dataMode)
    {
    }


    CoreSegmentQueryProcessor::CoreSegmentQueryProcessor(DataMode dataMode) :
        CoreSegmentQueryProcessorBase(dataMode), HasDataMode(dataMode)
    {
    }


    MemoryQueryProcessor::MemoryQueryProcessor(DataMode dataMode) :
        MemoryQueryProcessorBase(dataMode), HasDataMode(dataMode)
    {
    }

}


namespace armarx::armem::server::query_proc::wm_server
{
    ProviderSegmentQueryProcessor::ProviderSegmentQueryProcessor(DataMode dataMode) :
        ProviderSegmentQueryProcessorBase(dataMode), HasDataMode(dataMode)
    {
    }


    CoreSegmentQueryProcessor::CoreSegmentQueryProcessor(DataMode dataMode) :
        CoreSegmentQueryProcessorBase(dataMode),
        HasDataMode(dataMode)
    {
    }


    void CoreSegmentQueryProcessor::process(
        armem::wm::CoreSegment& result,
        const armem::query::data::CoreSegmentQuery& query,
        const CoreSegment& coreSegment) const
    {
        std::scoped_lock lock(coreSegment.mutex());
        CoreSegmentQueryProcessorBase::process(result, query, coreSegment);
    }


    MemoryQueryProcessor::MemoryQueryProcessor(DataMode dataMode) :
        MemoryQueryProcessorBase(dataMode),
        HasDataMode(dataMode)
    {
    }


}
