#pragma once

#include <QWidget>

class QPushButton;
class QLineEdit;
class QFileDialog;

namespace armarx::armem::gui
{

    class MemoryControlWidget : public QWidget
    {
        Q_OBJECT
        using This = MemoryControlWidget;

    public:

        MemoryControlWidget();

        QLineEdit* pathInputBox();
        QString getEnteredPath();

        QPushButton* openFileBrowserButton();

        QPushButton* storeInLTMButton();
        QPushButton* storeOnDiskButton();

    public slots:

        void openFileBrowser();

    signals:

        void storeInLTM();
        void storeOnDisk();

    private slots:


    signals:


    private:

        QLineEdit* _lineEdit;

        QPushButton* _openFileBrowserButton;

        QPushButton* _storeInLTMButton;
        QPushButton* _storeOnDiskButton;

    };

}
